﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.Concurrent;

namespace Microsoft.ParallelComputingPlatform.ParallelExtensions.Samples
{
    class ObjectPool<T>
    {
        private readonly Func<T> m_generator;
        private readonly ConcurrentQueue<T> m_data = new ConcurrentQueue<T>();

        public ObjectPool(Func<T> generator)
        {
            m_generator = generator;
        }

        public void PutObject(T item) { m_data.Enqueue(item); }

        public T GetObject()
        {
            T item;
            if (m_data.TryDequeue(out item)) return item;
            else return m_generator();
        }
    }
}
